.H 1 "Window Types"
Rtpi provides four windows that are not associated with the
debugging of a particular target system: the Rtpi window,
the Directory window, the Help window, and the Keyboard Input window.
The use of these windows is summarized below:
.VL 10 1
.LI "Rtpi"
This window connects rtpi with its debug agents
and is the first window created when the debugger is started.
Multiple connections may be made using Unix domain sockets for local agents
and Ethernet connections for agents running on remote targets.
.LI "Directory"
.br
Changes the current working directory of the debugger.
.LI "Help"
Describes the operators and user interface.
.LI "Keyboard Input"
.br
This window allows entered text to be edited, and keeps a history
of the typed commands.
Keyboard input typed to any window is echoed here.
.LE
.P
When a connection to a target system is opened a window is created
that depends on the target's configuration.
If a target has multiple processors a Processors window is created
to list the processor names.
Otherwise a window appropriate to the target processor's architecture
and operating system is created.
These windows are described below:
.VL 12 1
.LI "Processors"
Lists the names of processors available through the agent.
The processors may be opened from the line menus.
.LI "Dbmonpi"
This window is created for target processors running the debug monitor and
allows rtpi to attach to existing programs and down-load new ones.
The Dbmonpi window supports several processor types:
680X0, DSP32C, and WE32100.
.LI "Nrtxpi"
Debugs processes on 680X0 targets running
the real-time multi-tasking executive NRTX.
From the menu bar the Dbmonpi window for the processor may also be opened,
allowing the NRTX kernel to be debugged.
.LI "Remote Unix Pi"
.br
Debugs processes on targets running the Unix operating system.
The window provides the same interface as pi's Unix Pi window but
only a small debug server runs on the target.
The symbol table and source files are accessed locally,
so the host must mount the target's file systems.
It works with Sun-3, SPARC, and Silicon Graphics workstations,
and 80[34]86 based PCs.
.LI "Remote Directory"
.br
This window is available when the Remote Unix Pi window is open,
and changes the working directory of the debug server on the target.
It provides the same interface as the Directory window.
.LE
